import { ClassType } from "../graphq-compose-typescript";
import { StringKey } from "../utils";
import { Map } from "immutable";
declare const CONTEXT_PARAMETER: unique symbol;
export interface CtxConfig {
    position: number;
    get: string;
}
declare type ContextMap<T> = Map<StringKey<T>, CtxConfig>;
interface ClassWithContextMap<T> extends ClassType<T> {
    [CONTEXT_PARAMETER]?: ContextMap<T>;
}
export declare class ContextSpecKeeper {
    private setContextMap;
    private getContextMap;
    setContextParameter<T>(type: ClassWithContextMap<T>, method: StringKey<T>, config: CtxConfig): void;
    getContextParameterIndex<T>(type: ClassWithContextMap<T>, method: StringKey<T>): CtxConfig;
}
export {};
