import { GraphqlComposeTypescriptError, PropertyError } from "../error";
import { ResolverBuilder } from "../resolver-builder";
import { ComposeOutputType, SchemaComposer, ObjectTypeComposer } from "graphql-compose";
import { MountPoint, MountPointSpecKeeper } from "./mountpoint-spec-keeper";
import { ProvidenTypeConvertor } from "../providenTypeConvertor";
import { ClassSpecialist } from "../graphq-compose-typescript";
export declare class MountPointIsNull<T> extends PropertyError<T> {
    constructor(constructor: any, method: any);
}
export declare class InvalidMountPoint extends GraphqlComposeTypescriptError {
    mountPoint: MountPoint;
    constructor(mountPoint: MountPoint);
}
export declare class Mounter {
    protected typeConvertor: ProvidenTypeConvertor<ComposeOutputType<any, any>>;
    protected resolverBuilder: ResolverBuilder;
    protected classSpecialist: ClassSpecialist;
    protected mountPointSpecKeeper: MountPointSpecKeeper;
    constructor(typeConvertor: ProvidenTypeConvertor<ComposeOutputType<any, any>>, resolverBuilder: ResolverBuilder, classSpecialist: ClassSpecialist, mountPointSpecKeeper: MountPointSpecKeeper);
    getTC(composer: SchemaComposer<any>, point: MountPoint): ObjectTypeComposer;
    mountInstances(composer: SchemaComposer<any>, instances: any[]): void;
}
