import { ClassType, OutputTypeFn, ProvidenOutputType } from "../graphq-compose-typescript";
import { StringKey } from "../utils";
import { List, Map } from "immutable";
export declare type MountPoint = Exclude<ProvidenOutputType, []>;
export declare type MountPointFn = () => MountPoint;
declare const MOUNT_POINTS: unique symbol;
declare type MountPoints = List<MountPointFn>;
declare type MountPointsMap<T> = Map<StringKey<T>, MountPoints>;
interface ClassWithMountPointsMap<T> extends ClassType<T> {
    [MOUNT_POINTS]?: MountPointsMap<T>;
}
export declare class MountPointSpecKeeper {
    private setMountPointsMap;
    addMountPoint<T>(constructor: ClassWithMountPointsMap<T>, key: StringKey<T>, point: OutputTypeFn): void;
    getMountPointsMap<T>(constructor: ClassWithMountPointsMap<T>): MountPointsMap<T>;
}
export {};
