import { ClassSpecialist, ClassType, ProvidenType } from "./graphq-compose-typescript";
import { FieldSpecKeeper } from "./field-spec";
import { BaseQueue } from "./type-composer-creation/queue";
import { ComposerInstanceCreator } from "./type-composer-creation/composer-creator";
import { IOComposers } from "./utils";
import { ComposeInputType, ComposeOutputType, SchemaComposer } from "graphql-compose";
export declare type ComposeType = ComposeInputType | ComposeOutputType<any, any>;
export declare type ComposerIn<T extends ComposeType> = Extract<IOComposers, T>;
export declare class ProvidenTypeConvertor<T extends ComposeType, C extends ComposerIn<T> = ComposerIn<T>> {
    protected classSpec: ClassSpecialist;
    protected fieldSpec: FieldSpecKeeper;
    protected queue: BaseQueue<C>;
    protected creator: ComposerInstanceCreator<C>;
    protected schemaComposer: SchemaComposer<any>;
    constructor(classSpec: ClassSpecialist, fieldSpec: FieldSpecKeeper, queue: BaseQueue<C>, creator: ComposerInstanceCreator<C>, schemaComposer: SchemaComposer<any>);
    private readonly typeMapper;
    toComposeType(type: ProvidenType): T;
    classToComposeType(typeClass: ClassType): T;
}
