import { ClassType } from "../graphq-compose-typescript";
import { StringKey } from "../utils";
import { Map } from "immutable";
declare const SOURCE_CONFIG_MAP: unique symbol;
export interface SourceSpec {
    parameterIndex: number;
    property: string;
}
declare type SourceConfigMap<T> = Map<StringKey<T>, SourceSpec>;
export interface ClassWithSourceConfig<T> extends ClassType<T> {
    [SOURCE_CONFIG_MAP]?: SourceConfigMap<T>;
}
export declare class SourceArgSpecKeeper {
    protected getConfigMap<T>(type: ClassWithSourceConfig<T>): SourceConfigMap<T>;
    protected setConfigMap<T>(type: ClassWithSourceConfig<T>, map: SourceConfigMap<T>): Map<StringKey<T>, SourceSpec>;
    addSourceArgSpec<T>(constructor: ClassType<T>, method: StringKey<T>, spec: SourceSpec): void;
    getMethodSourceArgSpec<T>(constructor: ClassType<T>, method: StringKey<T>): SourceSpec;
}
export {};
