import { ArgumentsMapper, ClassType, DefaultContext, InputTypeFn, OutputTypeFn, TypeFn } from "../graphq-compose-typescript";
import { StringKey } from "../utils";
import { PropertyTypeConvertor } from "../argument-type-convertor";
import { ComposeFieldConfig, ComposeInputFieldConfig, ComposeInputType, ComposeOutputType, SchemaComposer } from "graphql-compose";
import { ArgumentsBuilder, ParamsNamesKeeper } from "../arguments-builder";
import { PropertyTypeKeeper } from "../metadata";
import { GraphQLFieldResolver } from "graphql";
export interface FieldCreator {
    createField<T>(constructor: ClassType<T>, typeFn: TypeFn, key: StringKey<T>): any;
}
export declare class OutputFieldCreator implements FieldCreator {
    protected argumentsBuilder: ArgumentsBuilder;
    protected argumentsMapper: ArgumentsMapper;
    protected propertyTypeConvertor: PropertyTypeConvertor<ComposeOutputType<any, any>>;
    protected propertyTypeKeeper: PropertyTypeKeeper;
    protected schemaComposer: SchemaComposer<any>;
    protected paramsNamesKeeper: ParamsNamesKeeper;
    constructor(argumentsBuilder: ArgumentsBuilder, argumentsMapper: ArgumentsMapper, propertyTypeConvertor: PropertyTypeConvertor<ComposeOutputType<any, any>>, propertyTypeKeeper: PropertyTypeKeeper, schemaComposer: SchemaComposer<any>, paramsNamesKeeper: ParamsNamesKeeper);
    protected createResolver<T>(constructor: ClassType<T>, key: StringKey<T>): GraphQLFieldResolver<T, any>;
    createField<T>(constructor: ClassType<T>, typeFn: OutputTypeFn, key: any): ComposeFieldConfig<T, DefaultContext<T>>;
}
export declare class InputFieldCreator implements FieldCreator {
    protected propertyTypeConvertor: PropertyTypeConvertor<ComposeInputType>;
    protected schemaComposer: SchemaComposer<any>;
    constructor(propertyTypeConvertor: PropertyTypeConvertor<ComposeInputType>, schemaComposer: SchemaComposer<any>);
    createField<T>(constructor: ClassType<T>, typeFn: InputTypeFn, key: StringKey<T>): ComposeInputFieldConfig;
}
